%{
  #include <iostream>
  #include <string>
  
  using namespace std;
  
  #define YYSTYPE string
  
  extern void yyerror(const char* str);
  extern void processHeader(const string& header);
  extern void processValue(const string& name, const string& value);
  
  extern "C"
  {
    int yylex();
    int yyparse();
  }
%}

%token COMMENT WORD EQUALS OBRACE EBRACE NEWLINE SPACE UCHAR
%token MODE_GLOBAL MODE_GROUPS MODE_CUT_DEF MODE_INVALID

%%

commands:
  /* empty */ | commands command;

command:
  header_set
  |
  value_set
  |
  COMMENT
  |
  SPACE
  |
  NEWLINE
  ;

header_set:
  OBRACE WORD EBRACE NEWLINE
  {
    processHeader($2);
  };

value_set:
  WORD EQUALS value NEWLINE
  {
    processValue($1, $3);
  };

value:
  /* empty */
  {
    $$ = "";
  }
  |
  subvalue
  {
    $$ = $1;
  }
  | value subvalue
  {
    $$ = $1 + $2;
  };

subvalue:
  COMMENT
  |
  WORD
  |
  EQUALS
  |
  OBRACE
  |
  EBRACE
  |
  SPACE
  |
  UCHAR
  ;

%%

extern "C"
{
  int yywrap()
  {
    return 1;
  }
}
