#ifndef MAIN_H
#define MAIN_H

#include "forensic.h"

#include <getopt.h>

#include <fcntl.h> // Used for open
#include <sys/stat.h> // Used for open
#include <sys/types.h> // Used for open
#include <unistd.h> // Used for close

#include <dirent.h> // To work with directories
#include <stdio.h>

#include <iostream>

using namespace std;
using namespace forensic;

/**
 * External prototype declaration for the lex parser.
 * \param configPtr A pointer to a configuration object.
 * \param filename The configuration file to parse.
 */
extern bool parse(Config* configPtr, const string& filename);

int main(int argc, char* argv[]);
void showUsage(int verbose);
void showLicense();
void writeToFile(const char* data, unsigned long length, unsigned long long offset, const CutDefinition& cut, const Config& config, const string& directoryPrefix);
bool makeDirectory(string directory);

#endif
