from distutils.core import setup, Extension
from distutils import sysconfig
import datetime

sysconfig._init_posix()
g = sysconfig._config_vars
g['CC'] = 'g++'
g['LDSHARED'] = 'g++ -shared'

module1 = Extension('exgrepc',
                    sources = ['exgrep_wrap.c','Exgrep.cpp','CutDefinition.cpp','Config.cpp','Parser.tab.c','Parser.yy.c'],
                    define_macros = [('_LARGEFILE_SOURCE',1),('_GNU_SOURCE',1),('_COMPILED_ON','"%s"' %(datetime.date.today()))],
                    include_dirs = ['.'],
                    libraries = ['pcre','stdc++']
                    )

setup (name = 'exgrep',
       version = '0.1',
       description = 'Exgrep is an extracting grep implementation',
       py_modules = ['exgrep'],
       ext_modules = [module1])

