#!/usr/bin/python2.3
# ******************************************************
# Copyright 2004: Commonwealth of Australia.
#
# Developed by the Computer Network Vulnerability Team,
# Information Security Group.
# Department of Defence.
#
# Michael Cohen <scudette@users.sourceforge.net>
#
# ******************************************************
#  Version: FLAG 0.4 (12-02-2004)
# ******************************************************
#
# * This program is free software; you can redistribute it and/or
# * modify it under the terms of the GNU General Public License
# * as published by the Free Software Foundation; either version 2
# * of the License, or (at your option) any later version.
# *
# * This program is distributed in the hope that it will be useful,
# * but WITHOUT ANY WARRANTY; without even the implied warranty of
# * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# * GNU General Public License for more details.
# *
# * You should have received a copy of the GNU General Public License
# * along with this program; if not, write to the Free Software
# * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
# ******************************************************

""" This is the GTK Server. Runs the flag framework together with the GTK UI. """

import UI
import gtk
import sys
import cgi

window=None
subwindow=None

def change(self,query_str):
    """ Callback function used to redraw the results of the processing on the main window """
    global window,subwindow,flag
    if not window or not subwindow: return
    print query_str
    import cgi
    import FlagFramework

    query = FlagFramework.query_type(cgi.parse_qsl(query_str))
    window.remove(subwindow)
    c =  flag.process_request(query)
    subwindow = c.display()
    window.add(subwindow)
    window.show_all()
    
def destroy_handler(widget):
    """ Handler called on window destroy """
    sys.exit(0)

if __name__ == "__main__":
    import FlagFramework

    #Create a new GTK window
    window = gtk.Window(gtk.WINDOW_TOPLEVEL)

    #Initialise the flag framework
    flag = FlagFramework.Flag(ui=UI.GTKUI)
    flag.ui = UI.GTKUI
   
    #Install the GTK callback
    flag.ui.link_callback = change
    
    #Start off with an empty query string
    query = FlagFramework.query_type(())
    a = flag.process_request(query)
    
    subwindow=a.display()
    window.add(subwindow)
    window.connect("destroy",destroy_handler)
    window.show_all()
    gtk.main()
